package cbor

import (
	"io"

	"github.com/polydawn/refmt/cbor"

	"gitlab.dms3.io/ld/go-ld-prime"
	"gitlab.dms3.io/ld/go-ld-prime/codec/dagcbor"
	"gitlab.dms3.io/ld/go-ld-prime/multicodec"
)

var (
	_ ld.Decoder = Decode
	_ ld.Encoder = Encode
)

func init() {
	multicodec.RegisterEncoder(0x51, Encode)
	multicodec.RegisterDecoder(0x51, Decode)
}

func Decode(na ld.NodeAssembler, r io.Reader) error {
	return dagcbor.Unmarshal(na, cbor.NewDecoder(cbor.DecodeOptions{}, r), false)
}

func Encode(n ld.Node, w io.Writer) error {
	return dagcbor.Marshal(n, cbor.NewEncoder(w), false)
}
