package dagcbor

import (
	"bytes"
	"io"
	"testing"

	. "github.com/warpfork/go-wish"

	cid "gitlab.dms3.io/dms3/go-cid"
	ld "gitlab.dms3.io/ld/go-ld-prime"
	cidlink "gitlab.dms3.io/ld/go-ld-prime/linking/cid"
	basicnode "gitlab.dms3.io/ld/go-ld-prime/node/basic"
)

func TestRoundtripCidlink(t *testing.T) {
	lp := cidlink.LinkPrototype{cid.Prefix{
		Version:  1,
		Codec:    0x71,
		MhType:   0x13,
		MhLength: 4,
	}}
	lsys := cidlink.DefaultLinkSystem()

	buf := bytes.Buffer{}
	lsys.StorageWriteOpener = func(lnkCtx ld.LinkContext) (io.Writer, ld.BlockWriteCommitter, error) {
		return &buf, func(lnk ld.Link) error { return nil }, nil
	}
	lsys.StorageReadOpener = func(lnkCtx ld.LinkContext, lnk ld.Link) (io.Reader, error) {
		return bytes.NewReader(buf.Bytes()), nil
	}

	lnk, err := lsys.Store(ld.LinkContext{}, lp, n)
	Require(t, err, ShouldEqual, nil)

	n2, err := lsys.Load(ld.LinkContext{}, lnk, basicnode.Prototype.Any)
	Require(t, err, ShouldEqual, nil)
	Wish(t, n2, ShouldEqual, n)
}
