package tests

import (
	"strings"

	refmtjson "github.com/polydawn/refmt/json"

	ld "gitlab.dms3.io/ld/go-ld-prime"
	"gitlab.dms3.io/ld/go-ld-prime/codec"
	"gitlab.dms3.io/ld/go-ld-prime/must"
	"gitlab.dms3.io/ld/go-ld-prime/traversal/selector"
)

// various benchmarks assign their final result here,
// in order to defuse the possibility of their work being elided.
var sink interface{}

func mustNodeFromJsonString(np ld.NodePrototype, str string) ld.Node {
	nb := np.NewBuilder()
	must.NotError(codec.Unmarshal(nb, refmtjson.NewDecoder(strings.NewReader(str))))
	return nb.Build()
}

func mustSelectorFromJsonString(np ld.NodePrototype, str string) selector.Selector {
	// Needing an 'ns' parameter here is sort of off-topic, to be honest.
	//  Someday the selector package will probably contain codegen'd nodes of its own schema, and we'll use those unconditionally.
	//  For now... we'll just use whatever node you're already testing, because it oughta work
	//   (and because it avoids hardcoding any other implementation that might cause import cycle funtimes.).
	seldefn := mustNodeFromJsonString(np, str)
	sel, err := selector.ParseSelector(seldefn)
	must.NotError(err)
	return sel
}
