package gengo

import (
	"testing"

	"gitlab.dms3.io/ld/go-ld-prime/node/tests"
	"gitlab.dms3.io/ld/go-ld-prime/schema"
)

func TestMapsContainingMaybe(t *testing.T) {
	t.Parallel()

	for _, engine := range []*genAndCompileEngine{
		{
			subtestName: "maybe-using-embed",
			prefix:      "maps-embed",
			adjCfg: AdjunctCfg{
				maybeUsesPtr: map[schema.TypeName]bool{"String": false},
			},
		},
		{
			subtestName: "maybe-using-ptr",
			prefix:      "maps-mptr",
			adjCfg: AdjunctCfg{
				maybeUsesPtr: map[schema.TypeName]bool{"String": false},
			},
		},
	} {
		t.Run(engine.subtestName, func(t *testing.T) {
			tests.SchemaTestMapsContainingMaybe(t, engine)
		})
	}
}

func TestMapsContainingMaps(t *testing.T) {
	t.Parallel()

	engine := &genAndCompileEngine{prefix: "maps-recursive"}
	tests.SchemaTestMapsContainingMaps(t, engine)
}

func TestMapsWithComplexKeys(t *testing.T) {
	t.Parallel()

	engine := &genAndCompileEngine{prefix: "maps-cmplx-keys"}
	tests.SchemaTestMapsWithComplexKeys(t, engine)
}
