package traversal_test

import (
	"testing"

	. "github.com/warpfork/go-wish"

	"gitlab.dms3.io/ld/go-ld-prime"
	"gitlab.dms3.io/ld/go-ld-prime/traversal"
)

func TestSelectLinks(t *testing.T) {
	t.Run("Scalar", func(t *testing.T) {
		lnks, _ := traversal.SelectLinks(leafAlpha)
		Wish(t, lnks, ShouldEqual, []ld.Link(nil))
	})
	t.Run("DeepMap", func(t *testing.T) {
		lnks, _ := traversal.SelectLinks(middleMapNode)
		Wish(t, lnks, ShouldEqual, []ld.Link{leafAlphaLnk})
	})
	t.Run("List", func(t *testing.T) {
		lnks, _ := traversal.SelectLinks(rootNode)
		Wish(t, lnks, ShouldEqual, []ld.Link{leafAlphaLnk, middleMapNodeLnk, middleListNodeLnk})
	})
}
